Draft PointArray: Difference between revisions

From FreeCAD Documentation
(Image caption; translate tags in correct location)
m (cleanup changed page name)
(12 intermediate revisions by 4 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
<translate>
<translate>
<!--T:21-->
{{Docnav
|[[Draft_PathArray|Path Array]]
|[[Draft_Clone|Clone]]
|[[Draft_Module|Draft]]
|IconL=Draft_PathArray.svg
|IconC=Workbench_Draft.svg
|IconR=Draft_Clone.svg
}}

<!--T:1-->
<!--T:1-->
{{GuiCommand
{{GuiCommand
Line 8: Line 18:
|MenuLocation=Draft → PointArray
|MenuLocation=Draft → PointArray
|Version=0.18
|Version=0.18
|SeeAlso=[[Draft Array|Draft Array]], [[Draft PathArray]]
|SeeAlso=[[Draft Array|Draft Array]], [[Draft PathArray|Draft PathArray]]
}}
}}


Line 14: Line 24:


<!--T:3-->
<!--T:3-->
The PointArray tool places copies of a selected shape along various selected points.
The {{Button|[[Image:Draft_PointArray.svg|16px]] [[Draft PointArray|Draft PointArray]]}} tool places copies of a selected shape along various selected points.


<!--T:15-->
The PointArray tool can be used on 2D shapes created with the [[Draft Workbench]], but can also be used on many types of 3D objects such as those created with the [[Part Workbench|Part]], [[PartDesign Workbench|PartDesign]], or [[Arch Workbench]]es.
The PointArray tool can be used on 2D shapes created with the [[Draft Workbench|Draft Workbench]], but can also be used on many types of 3D objects such as those created with the [[Part Workbench|Part]], [[PartDesign Workbench|PartDesign]], or [[Arch Workbench|Arch Workbench]]es.


<!--T:16-->
To position copies in an orthogonal array use [[Draft Array]]; to position copies along a path use [[Draft PathArray]]; to create copies or clones, and manually place them use [[Draft Move]], [[Draft Rotate]], and [[Draft Clone]].
To position copies in an orthogonal array use [[Draft Array|Draft Array]]; to position copies along a path use [[Draft PathArray|Draft PathArray]]; to create copies or clones, and manually place them use [[Draft Move|Draft Move]], [[Draft Rotate|Draft Rotate]], and [[Draft Clone|Draft Clone]].


</translate>
</translate>
[[Image:Draft_PointArray_Example.png|400px]]
[[Image:Draft_PointArray_Example.png|400px]]
<translate>
<translate>
<!--T:17-->
{{Caption|Object arranged at specific points}}
{{Caption|Object arranged at specific points}}


==How to use== <!--T:4-->
==Usage== <!--T:4-->


<!--T:5-->
<!--T:5-->
# Select an object that you wish to distribute.
# Select an object that you wish to distribute.
# Select a point compound.
# Select a point compound.
# Press the {{Button|[[Image:Draft_PointArray.svg|16px]] [[Draft PointArray]]}} button.
# Press the {{Button|[[Image:Draft_PointArray.svg|16px]] [[Draft PointArray|Draft PointArray]]}} button.


<!--T:18-->
To create a point compound select various [[Draft Point]]s and then press the {{Button|[[Image:Draft Upgrade.svg|16px]] [[Draft Upgrade]]}} button.
To create a point compound select various [[Draft Point|Draft Point]]s and then press the {{Button|[[Image:Draft Upgrade.svg|16px]] [[Draft Upgrade|Draft Upgrade]]}} button.


<!--T:19-->
Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.
Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.


Line 44: Line 59:


<!--T:9-->
<!--T:9-->
* {{PropertyData|Base}}: specifies the object to duplicate.
* {{PropertyData|Base}}: the object to duplicate.
* {{PropertyData|Count}}: (read-only) specifies the number of copies of the base object. This number will depend on the number of [[Draft Point]]s in the compound.
* {{PropertyData|Count}}: (read-only) specifies the number of copies of the base object. This number will depend on the number of [[Draft Point|Draft Point]]s in the compound.
* {{PropertyData|PointList}}: specifies the compound object with the points needed to place the copies of the base object.
* {{PropertyData|PointList}}: specifies a compound object with point objects that indicate where the copies of the {{PropertyData|Base}} object will appear.
The compound object needs to have a {{PropertyData|Links}}, {{PropertyData|Componets}}, or {{PropertyData|Geometry}} attribute. Each of the objects inside the compound should be [[Draft Point|Draft Points]] that have {{PropertyData|X}}, {{PropertyData|Y}}, and {{PropertyData|Z}} attributes.
The compounds could be created with [[Part Compound|Part Compound]] ({{PropertyData|Links}} attribute) or with [[Draft Upgrade|Draft Upgrade]] ({{PropertyData|Componets}} attribute).


==Scripting== <!--T:10-->
==Scripting== <!--T:10-->
{{Emphasis|See also:}} [[Draft API]] and [[FreeCAD Scripting Basics]].
{{Emphasis|See also:}} [[Draft API|Draft API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].


<!--T:11-->
<!--T:11-->
The PointArray tool can be used in [[macros]] and from the [[Python]] console by using the following function:
The PointArray tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:
</translate>
</translate>
{{Code|code=
{{Code|code=
Line 85: Line 102:
<translate>
<translate>


<!--T:20-->
{{Draft Tools navi}}
{{Docnav
{{Userdocnavi}}
|[[Draft_PathArray|Path Array]]
|[[Draft_Clone|Clone]]
|[[Draft_Module|Draft]]
|IconL=Draft_PathArray.svg
|IconC=Workbench_Draft.svg
|IconR=Draft_Clone.svg
}}

</translate>
</translate>
{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{clear}}
{{clear}}

Revision as of 11:45, 25 February 2020

Draft PointArray

Menu location
Draft → PointArray
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
0.18
See also
Draft Array, Draft PathArray

Description

The Draft PointArray tool places copies of a selected shape along various selected points.

The PointArray tool can be used on 2D shapes created with the Draft Workbench, but can also be used on many types of 3D objects such as those created with the Part, PartDesign, or Arch Workbenches.

To position copies in an orthogonal array use Draft Array; to position copies along a path use Draft PathArray; to create copies or clones, and manually place them use Draft Move, Draft Rotate, and Draft Clone.

Object arranged at specific points

Usage

  1. Select an object that you wish to distribute.
  2. Select a point compound.
  3. Press the Draft PointArray button.

To create a point compound select various Draft Points and then press the Draft Upgrade button.

Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

Options

There are no options for this tool. Either it works with the selected objects or not.

Properties

  • DataBase: the object to duplicate.
  • DataCount: (read-only) specifies the number of copies of the base object. This number will depend on the number of Draft Points in the compound.
  • DataPointList: specifies a compound object with point objects that indicate where the copies of the DataBase object will appear.

The compound object needs to have a DataLinks, DataComponets, or DataGeometry attribute. Each of the objects inside the compound should be Draft Points that have DataX, DataY, and DataZ attributes. The compounds could be created with Part Compound (DataLinks attribute) or with Draft Upgrade (DataComponets attribute).

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The PointArray tool can be used in macros and from the Python console by using the following function:

PointArray = makePointArray(base, ptlst)
  • Creates a PointArray object from the base object, by placing the copies along ptlst.
  • ptlst is an object with Geometry, Links, or Components attributes that define the position of the copies.

Example:

import FreeCAD, Draft

Polygon = Draft.makePolygon(3, radius=500.0)

p1 = Draft.makePoint(FreeCAD.Vector(1500, 0, 0))
p2 = Draft.makePoint(FreeCAD.Vector(2500, 0, 0))
p3 = Draft.makePoint(FreeCAD.Vector(2000, 1000, 0))

# Create a compound of points
addList, deleteList = Draft.upgrade([p1, p2, p3])

# Extract the compound from the list
compound = addList[0]

PointArray = Draft.makePointArray(Polygon, compound)